(   Title:  Enhanced error reporting for mftester.fs
     File:  mftester-errors.fs
   Author:  David N. Williams
  License:  Public Domain
  Version:  1.4.3, January 18, 2021
Generated:  January 18, 2021 from tester-errors.tmpl

This code assumes that mftester.fs and tester-display.fs are loaded.
)

VARIABLE MFT-#ERRORS    0 MFT-#ERRORS !
: MFT-ERROR1  ( c-addr u -- )
(
Display an error message followed by the line that had the error.
)
  red-text 1 MFT-#ERRORS +! MFT-ERROR-DEFAULT normal-text ;
\ ' MFT-ERROR1 MFT-ERROR-XT !

\ display results and goals
: mft-a.  ( 'buffer c-addr u -- )
  blue-text type
  ( 'buffer) dup >r @ dup
  IF   1- r> cell+ swap cells over +  \ display deepest first
       DO i mf@ mf. space -1 cells +LOOP
  ELSE r> 2drop ." none" THEN cr normal-text ;

: MFT-ERROR2  ( c-addr u -- )
  MFT-ERROR1
  MFT-RESULTS s" mfresults: " mft-a.
  MFT-GOALS   s"   mfgoals: " mft-a. ;
\ ' MFT-ERROR2 MFT-ERROR-XT !

\ fancy results and goals display
: mft-fancy-a.  ( 'buffer c-addr u -- )
  blue-text type
  ( 'buffer) dup @ swap cell+ swap ?dup
  IF   ( n) 1- 0 swap  \ display deepest first
       DO ( 'elem) i cells over + mf@
         i 1+ MFT-ERROR-INDEX @ =
         IF red-text mf. blue-text ELSE mf. THEN space
       -1 +LOOP
  ELSE ." none" THEN drop cr normal-text ;

: MFT-ERROR3  ( c-addr u -- )
  MFT-ERROR1
  MFT-RESULTS s" mfresults: " mft-fancy-a.
  MFT-GOALS   s"   mfgoals: " mft-fancy-a. ;
' MFT-ERROR3 MFT-ERROR-XT !

: .mft-errors   ( -- )
  blue-text ." MFT-ERRORS: " normal-text MFT-#ERRORS @ . ;
: ?.mft-errors  ( -- )  VERBOSE @ IF .mft-errors THEN ;
