(   Title:  Enhanced error reporting for qtester.fs
     File:  qtester-errors.fs
   Author:  David N. Williams
  License:  Public Domain
  Version:  1.4.3, January 18, 2021
Generated:  January 18, 2021
)

(
This code assumes that qtester.fs is loaded.
)

VARIABLE QT-#ERRORS    0 QT-#ERRORS !
: QT-ERROR1  ( c-addr u -- )
(
Display an error message followed by the line that had the error.
)
  red-text 1 QT-#ERRORS +! QT-ERROR-DEFAULT normal-text ;
\ ' QT-ERROR1 QT-ERROR-XT !

\ display results and goals
: qt-a.  ( 'buffer c-addr u -- )
  blue-text type
  ( 'buffer) dup >r @ dup
  IF   1- r> cell+ swap cells over +  \ display deepest first
       DO i q@ q. space -1 cells +LOOP
  ELSE r> 2drop ." none" THEN cr normal-text ;

: QT-ERROR2  ( c-addr u -- )
  QT-ERROR1
  QT-RESULTS s" qresults: " qt-a.
  QT-GOALS   s"   qgoals: " qt-a. ;
\ ' QT-ERROR2 QT-ERROR-XT !

\ fancy results and goals display
: qt-fancy-a.  ( 'buffer c-addr u -- )
  blue-text type
  ( 'buffer) dup @ swap cell+ swap ?dup
  IF   ( n) 1- 0 swap  \ display deepest first
       DO ( 'elem) i cells over + q@
         i 1+ QT-ERROR-INDEX @ =
         IF red-text q. blue-text ELSE q. THEN space
       -1 +LOOP
  ELSE ." none" THEN drop cr normal-text ;

: QT-ERROR3  ( c-addr u -- )
  QT-ERROR1
  QT-RESULTS s" qresults: " qt-fancy-a.
  QT-GOALS   s"   qgoals: " qt-fancy-a. ;
' QT-ERROR3 QT-ERROR-XT !

: .qt-errors   ( -- )
  blue-text ." QT-ERRORS: " normal-text QT-#ERRORS @ . ;
: ?.qt-errors  ( -- )  VERBOSE @ IF .qt-errors THEN ;
